From 70aaa116eb0b340e44f75e94e2159d41d8b2ecde Mon Sep 17 00:00:00 2001
From: Jo-Philipp Wich <jow@openwrt.org>
Date: Sun, 12 Aug 2012 13:20:27 +0000
Subject: [PATCH] base-files: provide a sysupgrade -r (--restore-backup) option
 as convenience wrapper for tar -C / -x(v)zf

SVN-Revision: 33147
---
 package/base-files/Makefile              |  2 +-
 package/base-files/files/sbin/sysupgrade | 12 ++++++++++++
 2 files changed, 13 insertions(+), 1 deletion(-)

diff --git a/package/base-files/Makefile b/package/base-files/Makefile
index 441d394288..50ad7d4a0c 100644
--- a/package/base-files/Makefile
+++ b/package/base-files/Makefile
@@ -11,7 +11,7 @@ include $(INCLUDE_DIR)/kernel.mk
 include $(INCLUDE_DIR)/version.mk
 
 PKG_NAME:=base-files
-PKG_RELEASE:=114
+PKG_RELEASE:=115
 
 PKG_FILE_DEPENDS:=$(PLATFORM_DIR)/ $(GENERIC_PLATFORM_DIR)/base-files/
 PKG_BUILD_DEPENDS:=opkg/host
diff --git a/package/base-files/files/sbin/sysupgrade b/package/base-files/files/sbin/sysupgrade
index 62a4012a32..802848ade7 100755
--- a/package/base-files/files/sbin/sysupgrade
+++ b/package/base-files/files/sbin/sysupgrade
@@ -11,6 +11,7 @@ export SAVE_OVERLAY=0
 export DELAY=
 export CONF_IMAGE=
 export CONF_BACKUP=
+export CONF_RESTORE=
 export HELP=0
 export FORCE=0
 
@@ -24,6 +25,7 @@ while [ -n "$1" ]; do
 		-n) export SAVE_CONFIG=0;;
 		-c) export SAVE_OVERLAY=1;;
 		-b|--create-backup) export CONF_BACKUP="$2"; shift;;
+		-r|--restore-backup) export CONF_RESTORE="$2"; shift;;
 		-f) export CONF_IMAGE="$2"; shift;;
 		-F|--force) export FORCE=1;;
 		-h|--help) export HELP=1; break;;
@@ -55,6 +57,10 @@ Options:
 	             create .tar.gz of files specified in sysupgrade.conf
 	             then exit. Does not flash an image. If file is '-',
 	             i.e. stdout, verbosity is set to 0 (i.e. quiet).
+	-r / --restore-backup <file>
+	             restore a .tar.gz created with sysupgrade -b
+	             then exit. Does not flash an image. If file is '-',
+	             the archive is read from stdin.
 	-n           do not save configuration over reflash
 	-F / --force
 	             Flash image even if image checks fail, this is dangerous!
@@ -126,6 +132,12 @@ if [ -n "$CONF_BACKUP" ]; then
 	exit $?
 fi
 
+if [ -f "$CONF_RESTORE" ] || [ "$CONF_RESTORE" = "-" ]; then
+	[ "$VERBOSE" -gt 1 ] && TAR_V="v" || TAR_V=""
+	tar -C / -x${TAR_V}zf "$CONF_RESTORE"
+	exit $?
+fi
+
 type platform_check_image >/dev/null 2>/dev/null || {
 	echo "Firmware upgrade is not implemented for this platform."
 	exit 1
-- 
2.30.2